(*
  PWPW  Ver. 1.00
  
  Copyright (C) 2003 lethevert
  All rights reserved.
  
  web : http://www.geocities.jp/lethevert/index.html
  mail: lethevert@egroups.co.jp
  
  
  This file is part of PWPW.
  
  PWPW is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  PWPW is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public
  License along with PWPW; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)
library PWPW;

uses
  SysUtils,
  Windows,
  Classes,
  Controls,
  Forms,
  CLCLPlugin,
  PWManModule in 'PWManModule.pas' {FrmPWMan},
  InitFocusModule in 'InitFocusModule.pas',
  PasswordGeneratorModule in 'PasswordGeneratorModule.pas';

{$R *.res}

function create_folder(title: PAnsiChar): PDATA_INFO;
var
   folder_di: PDATA_INFO;
begin
   folder_di := PDATA_INFO(LocalAlloc(LPTR, SizeOf(DATA_INFO)));
   if folder_di = Nil then // Error
   Begin
      Result := Nil;
      Exit;
   End;
   folder_di^.struct_size := SizeOf(DATA_INFO);
   folder_di^._type := TYPE_FOLDER;
   folder_di^.title := PAnsiChar(LocalAlloc(LPTR, SizeOf(AnsiChar)*(StrLen(title)+1)));
   if folder_di^.title <> Nil then
      StrCopy(folder_di^.title, title);
   //CreateAndSortItemData()ƓlɁAȉ̕͏肭ȂB
   //folder_di := PDATA_INFO(SendMessage(hWnd, WM_ITEM_CREATE, LPARAM(PAnsiChar('New Password')), TYPE_FOLDER));
   
   Result := folder_di;
end;

function get_tool_info(hWnd: HWND; index: Integer; tgi: PTOOL_GET_INFO): LongBool; stdcall;
begin
   { āALocalAllocׂȂ̂ȁH}
   Case index of
      0:
         begin
            StrCopy(tgi^.title, PAnsiChar('pX[h}l[W'));
            StrCopy(tgi^.func_name, PAnsiChar('run_pwpw'));
            StrCopy(tgi^.cmd_line, PAnsiChar(''));
            tgi^.call_type := CALLTYPE_MENU;
            Result := TRUE;
         end;
   else
      Result := FALSE;
   end;
end;

function run_pwpw(hWnd: HWND; tei: PTOOL_EXEC_INFO; tdi: PTOOL_DATA_INFO): Integer; stdcall;
var
   hdi       : PDATA_INFO;
   folder_di : PDATA_INFO;
   pw_folder : PDATA_INFO;
   tr_folder : PDATA_INFO;
//   PWInitFocus: InitFocus;
begin
   pw_folder := nil;
   tr_folder := nil;
   
   { o^ACe̎擾 }
   hdi := PDATA_INFO(SendMessage(hWnd, WM_REGIST_GET_ROOT, 0, 0));
   if hdi = nil then
   begin
      Result := TOOL_ERROR;
      Exit;
   end;
   
   { PasswordtH_TrashtH_擾 }
   folder_di := hdi^.child;
   while folder_di <> nil do
   begin
      if folder_di^._type = TYPE_FOLDER then
      begin
         if AnsiStrLComp(folder_di^.title, PAnsiChar('Password'), 8) = 0 then
         begin
            pw_folder := folder_di;
         end
         else if AnsiStrLComp(folder_di^.title, PAnsiChar('Trash'), 5) = 0 then
         begin
            tr_folder := folder_di;
         end;
      end;
      folder_di := folder_di^.next;
   end;
   { TrashtH_ȂƂ́A쐬 }
   if tr_folder = nil then
   begin
      tr_folder := create_folder(PAnsiChar('Trash'));
      tr_folder^.next := hdi^.child;
      hdi^.child := tr_folder;
      {
      // AőOʂɕ\łȂ񂾂ȁ`B
      // AmF_CAOoȂŁAɍ쐬邱ƂɂB
      if Application.MessageBox('TrashtH_܂BVK쐬܂H', 'PWPW', MB_YESNO) = IDYES then
      begin
         
      end
      else
      begin
         Result := TOOL_ERROR;
         Exit;
      end;
      }
   end;
   { PasswordtH_ȂƂ́A쐬 }
   if pw_folder = nil then
   begin
      pw_folder := create_folder(PAnsiChar('Password'));
      pw_folder^.next := hdi^.child;
      hdi^.child := pw_folder;
      {
      // AőOʂɕ\łȂ񂾂ȁ`B
      // AmF_CAOoȂŁAɍ쐬邱ƂɂB
      if Application.MessageBox('PasswordtH_܂BVK쐬܂H', 'PWPW', MB_YESNO) = IDYES then
      begin
         
      end
      else
      begin
         Result := TOOL_ERROR;
         Exit;
      end;
      }
   end;

   { PWMantH[𐶐 }
   if FrmPWMan = nil then
      FrmPWMan := TFrmPWMan.Create(nil); (* Ƃ́ACƂ͐ႤB *)
   FrmPWMan.ComboBox1.Clear;
   FrmPWMan.MyInitialize(pw_folder, tr_folder, hWnd);
   // ConboBoxɃXgZbg
   folder_di := hdi^.child;
   while folder_di <> nil do
   begin
      if folder_di^._type = TYPE_FOLDER then
      begin
         FrmPWMan.ComboBox1.Items.AddObject(folder_di^.title, Pointer(folder_di));
      end;
      folder_di := folder_di^.next;
   end;
   FrmPWMan.Show;
   Application.Run;
   { Window̃tH[JXA֐IACLCL̑Ńc[ĂяoOwindowɖ߂B
     viewer_tool_execute@Viewer.c L.1911
     SetFocus(focus_wnd)Ă΂āAtH[JXZbgĂB
     
     Ƃ肠̉ƂāAVXbh쐬āAsleep̌ɃtH[JXڂB
   }
//   PWInitFocus := InitFocus.Create(False);
   InitFocus.Create(False);
   
   Result := TOOL_SUCCEED;
   
end;

function run_pwpw_property(hWnd: HWND; tei: PTOOL_EXEC_INFO): LongBool; stdcall;
begin
   Result := FALSE;
end;

exports
   get_tool_info,
   run_pwpw,
   run_pwpw_property;

begin
end.
